100 REMark ***************************************
110 REMark **             QSquidge              **
120 REMark **     Programmed by Ian Swinton     **
130 REMark **        and Alan Glassbrook        **
140 REMark ** With thanks to  Sinclair QL World **
150 REMark ** Original concept by Kevin Swinton **
160 REMark **  Arcade/Adventure : October 1987  **
170 REMark ***************************************
180 :
190 MODE 8
200 REPeat forever
210   POKE 98403,2 : REMark screen_off
220   set_up_screen
230   initialise_variables
240   read_in_location_data
250   stars 438,170
260   floor
270   POKE 98403,8 : REMark switch to MODE 8
280   space
290   text
300   time
310   IF finish_game = 1 THEN 
320     gameover
330   ELSE 
340     lose
350   END IF 
360   PAUSE
370 END REPeat forever
380 :
390 :
400 DEFine PROCedure set_up_screen
410   INK 7
420   OPEN #2,con_512x256a0x0
430   CLS #2
440   SCALE 1200,-180,-30
450   WINDOW 440,250,36,6
460   OVER -1 : CURSOR 400,10
470   PRINT '' : REMark CTRL SHIFT .
480   REMark CHR$(158)
490   OVER 0
500 END DEFine 
510 :
520 :
530 DEFine PROCedure stars(maxx,maxy)
540   FOR star = 1 TO 70
550     BLOCK 2,1,RND(maxx),RND(maxy),RND(1 TO 7)
560   END FOR star
570 END DEFine 
580 :
590 :
600 DEFine PROCedure floor
610   INK 1 : FILL 1
620   LINE 40,412 TO 1240,812
630   LINE 1240,812 TO 320,812
640   LINE 320,812 TO 40,412
650   LINE 40,412 TO 1240,812
660   LINE 1240,812 TO 960,412
670   FILL 0
680 END DEFine 
690 :
700 :
710 DEFine PROCedure door(no)
720   INK 6 : OVER -1
730   SELect ON no
740     = 1 : INK 7 : LINE 700,812 TO 700,1000 TO 900,1000 TO 900,812
750     = 2 : LINE 1034,532 TO 1034,692 TO 1099,792 TO 1099,632
760     = 3 : LINE 400,412 TO 400,612 TO 600,612 TO 600,412
770     = 4 : INK 7 : LINE 128,542 TO 128,702 TO 206,818 TO 206,648
780   END SELect 
790   OVER 0
800 END DEFine 
810 :
820 :
830 DEFine PROCedure text
840   PAPER 0 : INK 6 : CSIZE 0,0
850   AT 18,14 : PRINT 'QSQUIDGE'
860   CSIZE 0,0 : INK 3 : AT 19,14
870   PRINT '~~~~~~~~' : INK 6
875   AT 20,2:PRINT 'Original Concept by Kevin Swinton':INK 5
880   AT 21,6 : PRINT 'Programmed by Ian Swinton'\TO 9;'and Alan Glassbrook'
900   INK 2 : AT 24,9 : PRINT 'Pieces collected:'
910   AT 24,26 : PRINT '00'
920   AT 24,28 - LEN(pieces) : PRINT pieces
930   BLOCK 400,1,20,170,3
940 END DEFine 
950 :
960 :
970 DEFine PROCedure time
980   r 1,6 : INK 3
990   AT 23,9 : PRINT "TIME REMAINING:";
1000   INK 7 : PRINT '3:00'
1010   prnt : BEEP 20000,0,15,5,10,8,0,0
1020   REPeat control_loop
1030     keycheck : dec = dec - 32 : INK 7
1040     IF dec <= 0 THEN 
1050       dec = 199 : sec = sec - 1
1060       IF sec = -1 THEN 
1070         sec = 59 : min = min - 1
1080       END IF 
1090       AT 23,24 : PRINT min;':';sec;' '
1100     END IF 
1110     IF min<= 0 AND sec<= 0 AND bitheld = 0 THEN 
1120       show_lives : min = 3 : sec = 0
1130     ELSE 
1140       IF bitheld = 1 THEN 
1150         min = 3 : sec = 0 : bitheld = 0
1160       END IF 
1170     END IF 
1180     IF finish_game = 1 THEN 
1190       EXIT control_loop
1200     END IF 
1210     IF lives = 0 THEN 
1220       PAUSE 100 : EXIT control_loop
1230     END IF 
1240   END REPeat control_loop
1250 END DEFine 
1260 :
1270 :
1280 DEFine PROCedure keycheck
1290   IF KEYROW(4) = 4  THEN wait
1300   IF KEYROW(2) = 2  THEN left
1310   IF KEYROW(7) = 8  THEN right
1320   IF KEYROW(4) = 32 THEN up
1330   IF KEYROW(4) = 1  THEN down
1340   IF KEYROW(5) = 32 THEN check
1350 END DEFine 
1360 :
1370 :
1380 DEFine PROCedure left
1390   prnt
1400   sx = sx - 32
1410   IF sx< 760 - (sy - 84) AND sy > 430 AND sy < 460 AND d(4) = 1 THEN 
1420     locate 1
1430   ELSE 
1440     IF sx < 769 - (sy - 84) THEN 
1450       sx = sx + 32
1460     END IF 
1470   END IF 
1480   prnt
1490 END DEFine 
1500 :
1510 :
1520 DEFine PROCedure right
1530   prnt
1540   sx = sx + 32
1550   IF sx>1720 - (sy - 84) AND sy > 430 AND sy < 460 AND d(2) = 1 THEN 
1560     locate 4
1570   ELSE 
1580     IF sx > 1720 - (sy - 84) THEN 
1590       sx = sx - 32
1600     END IF 
1610   END IF 
1620   prnt
1630 END DEFine 
1640 :
1650 :
1660 DEFine PROCedure up
1670   prnt
1680   sx = sx + 16 : sy = sy - 16
1690   IF sx > 979 AND sx < 1141 AND sy < 268 AND d(1) = 1 THEN 
1700     locate 3
1710   END IF 
1720   IF sy < 268 THEN 
1730     sy = sy + 16 : sx = sx - 16
1740   END IF 
1750   prnt
1760 END DEFine 
1770 :
1780 :
1790 DEFine PROCedure down
1800   prnt
1810   sx = sx - 16 : sy = sy + 16
1820   IF sx > 675 AND sx < 805 AND sy > 588 AND d(3) = 1 THEN 
1830     locate 2
1840   END IF 
1850   IF sy > 588 THEN 
1860     sy = sy - 16 : sx = sx + 16
1870   END IF 
1880   prnt
1890 END DEFine 
1900 :
1910 :
1920 DEFine PROCedure prnt
1930   INK 7 : OVER -1
1940   CURSOR sx / 4,sy / 4
1950   PRINT '' : REMark CTRL SHIFT .
1960   REMark CHR$(158)
1970   IF NOT BEEPING THEN BEEP 1,10,15,5,100,0,12,0
1980   OVER 0 : dec = dec - 7
1990 END DEFine 
2000 :
2010 :
2020 DEFine PROCedure locate(future)
2030   SELect ON future
2040     = 1 : IF roomx > 1 THEN r roomx,roomy                                     : roomx = roomx - 1 : r roomx,roomy                                   : sx = 1348
2050     = 2 : IF roomy < 16 THEN r roomx,roomy                                    : roomy = roomy + 1 : r roomx,roomy                                   : sy = 290 : sx = 1050
2060     = 3 : IF roomy > 1 THEN r roomx,roomy                                     : roomy = roomy - 1 : r roomx,roomy                                   : sy = 580 : sx = 765
2070     = 4 : IF roomx < 16 THEN r roomx,roomy                                    : roomx = roomx + 1 : r roomx,roomy                                   : sx = 388
2080   END SELect 
2090 END DEFine 
2100 :
2110 :
2120 DEFine PROCedure initialise_variables
2130   DIM d(5),finit$(30),M$(20),mt$(10)
2140   DIM congrat$(20),log$(8),a$(2),message$(255)
2150   DIM endmessage$(30),char$(10),word$(10)
2160   REMark Next line speeds up cursor
2170   POKE_W 163982,-255 : POKE_W 163980,9
2180   sx = 692 : sy = 404 : min = 3 : pieces = 0
2190   bitheld = 0 : finish_game = 0 : lives = 3
2200   roomx = 1 : roomy = 6 : sec = 0 : dec = 199
2210   shipcol = 0 : fuelcol = 0 : chipcol = 0
2220 END DEFine 
2230 :
2240 :
2250 DEFine PROCedure space
2260   mes 150,200,'PRESS SPACE'
2270   REPeat get_spacebar
2280     a$ = INKEY$
2290     IF a$ = ' ' THEN EXIT get_spacebar
2300   END REPeat get_spacebar
2310   mes 150,200,'PRESS SPACE'
2320 END DEFine 
2330 :
2340 :
2350 DEFine PROCedure mes(wordx,wordy,message$)
2360   INK 1 : OVER -1
2370   CURSOR wordx,wordy
2380   PRINT message$ : INK 5
2390   CURSOR wordx - 4,wordy + 2
2400   PRINT message$ : OVER 0
2410 END DEFine 
2420 :
2430 :
2440 DEFine PROCedure wait
2450   mes 10,20,"TIME HELD"
2460   REPeat hold
2470     IF KEYROW(2) = 8 THEN EXIT hold
2480   END REPeat hold
2490   mes 10,20,"TIME HELD"
2500 END DEFine 
2510 :
2520 :
2530 DEFine PROCedure gameover
2540   finish_game = 0
2550   finit$ = "G A M E  O V E R !"
2560   OVER #2,-1 : CSIZE #2,0,1
2570   FOR f = 1 TO LEN(finit$)
2580     INK RND(2 TO 7)
2590     CURSOR #2,50 + (f * 20),100
2600     PRINT #2;finit$(f);
2610     BEEP 1000,0 + (f)
2620     PAUSE 2
2630   END FOR f
2640   OVER #2,0 : PAUSE 200
2650   BEEP 500,0
2660   congratulations
2670 END DEFine 
2680 :
2690 :
2700 DEFine PROCedure read_in_location_data
2710   RESTORE 2840
2720   DIM location$(8,8,10)
2730   FOR gridx = 1 TO 8
2740     FOR gridy = 1 TO 8
2750       READ word$
2760       location$(gridy,gridx) = word$
2770     END FOR gridy
2780   END FOR gridx
2790 END DEFine 
2800 :
2810 :
2820 REMark Data for the 64 screens.
2830 :
2840 DATA 'rd','ld','dr','ld','rd','lf','r','ld'
2850 DATA 'ud','ud','ud','ud','ur','lrd','lcr','lud'
2860 DATA 'ud','ud','ud','ur','lr','lfu','rd','lud'
2870 DATA 'ud','ud','ud','dsr','lr','lr','lu','ud'
2880 DATA 'ud','ur','lu','udr','lr','lr','l','ud'
2890 DATA 'ur','lc','cd','udr','l','dr','lr','lus'
2900 DATA 'rd','lr','ul','ur','lr','lsur','lr','ld'
2910 DATA 'ur','lr','lr','lr','lr','rfl','lr','lu'
2920 :
2930 :
2940 DEFine PROCedure r(xp,yp)
2950   FOR dd = 1 TO 4
2960     d(dd) = 0
2970   END FOR dd
2980   partship = 0 : fuelpod = 0 : microchip = 0
2990   mt$ = location$(xp,yp)
3000   FOR readthru = 1 TO LEN(mt$)
3010     char$ = mt$(readthru)
3020     IF char$ = 'u' THEN door 1 : d(1) = 1
3030     IF char$ = 'r' THEN door 2 : d(2) = 1
3040     IF char$ = 'd' THEN door 3 : d(3) = 1
3050     IF char$ = 'l' THEN door 4 : d(4) = 1
3060     IF char$ = 'f' THEN fuelpod = 1 : bit 2
3070     IF char$ = 's' THEN partship = 1 : bit 1
3080     IF char$ = 'c' THEN microchip = 1 : bit 3
3090   END FOR readthru
3100 END DEFine 
3110 :
3120 :
3130 DEFine PROCedure bit(object)
3140   INK 4 : OVER #2,-1
3150   CSIZE #2,3,1 : AT #2,5,16
3160   SELect ON object
3170     =1:PRINT #2,'';:REMark CTRL SHIFT L(Ship)
3180     =2:PRINT #2,'';:REMark CTRL SHIFT W(Fuel)
3190     =3:PRINT #2,'=';:REMark      EQUAL  (Chip)
3200   END SELect 
3210   CSIZE #2,0,0 : OVER #2,0
3220 END DEFine 
3230 :
3240 :
3250 DEFine PROCedure check
3260   pc = 0
3270   IF partship = 1 THEN wipe_ship : pc = 1
3280   IF fuelpod = 1 THEN wipe_fuel : pc = 1
3290   IF microchip = 1 THEN wipe_chip : pc = 1
3300   IF pc = 1 THEN 
3310     pieces = pieces + 1 : BEEP 1000,1 : min = 3
3320     INK 2 : AT 24,28 - LEN(pieces)
3330     PRINT pieces : bitheld = 1
3340   END IF 
3350   IF shipcol=3 AND fuelcol=3 AND chipcol=3 THEN 
3360     finish_game = 1
3370   END IF 
3380 END DEFine 
3390 :
3400 :
3410 DEFine PROCedure wipe_ship
3420   shipcol = shipcol + 1
3430   FOR take = 1 TO LEN(mt$)
3440     IF mt$(take) = 's' THEN mt$(take) = '0'
3450   END FOR take
3460   location$(roomx,roomy) = mt$
3470   partship = 0 : bit 1
3480 END DEFine 
3490 :
3500 :
3510 DEFine PROCedure wipe_fuel
3520   fuelcol = fuelcol + 1
3530   FOR take = 1 TO LEN(mt$)
3540     IF mt$(take) = 'f' THEN mt$(take) = '0'
3550   END FOR take
3560   location$(roomx,roomy) = mt$
3570   fuelpod = 0 : bit 2
3580 END DEFine 
3590 :
3600 :
3610 DEFine PROCedure wipe_chip
3620   chipcol = chipcol + 1
3630   FOR take = 1 TO LEN(mt$)
3640     IF mt$(take) = 'c' THEN mt$(take) = '0'
3650   END FOR take
3660   location$(roomx,roomy) = mt$
3670   microchip = 0 : bit 3
3680 END DEFine 
3690 :
3700 :
3710 DEFine PROCedure congratulations
3720   MODE 8 : col = 0
3730   CSIZE 0,1 : RESTORE 3900
3740   FOR blob = 0 TO 8
3750     col = col + 1
3760     READ congrat$
3770     IF congrat$ = '' THEN PRINT : craft
3780     IF col = 8 THEN col = 1
3790     INK col
3800     IF blob > 5 THEN
3810       PRINT TO 10 ; congrat$
3820     ELSE
3830       PRINT congrats
3840     END IF
3850   END FOR blob
3860   CSIZE #3,0,0 : CSIZE 0,0
3870 END DEFine 
3880 :
3890 :
3900 DATA 'Well Done !!!','You have helped'
3910 DATA 'SQUIDGE to return'
3920 DATA 'to his home planet','PAVLONIA....'
3930 DATA '','Press any key','for another'
3940 DATA 'quest !!!!'
3950 :
3960 :
3970 DEFine PROCedure craft
3980   OPEN #3,scr_100x200a340x20
3990   OPEN #4,scr_330x20a30x130
4000   rocket : logo : INK #4,4
4010   PRINT #4,'__' : INK #4,6
4020   OVER #4,-1 : AT #4,0,0
4030   PRINT #4,' ' : OVER #4,0
4040   REMark '<SPACE> CTRL SHIFT .'
4050   BEEP 0,255 : INK #4,4
4060   FOR ac = 1 TO 88
4070     AT #4,0,0
4080     PRINT #4,'_'
4090     PAN #4,4
4100   END FOR ac
4110   BEEP : PAUSE 50 : BEEP 0,250
4120   FOR ac = 1 TO 86
4130     PAN #4,-4
4140   END FOR ac
4150   BEEP : PAUSE 150
4160   FOR bep = 56 TO 28 STEP -1
4170     BEEP 0,bep,bep+2,.5,.5,5,10,10
4180   END FOR bep
4190   sc = 0
4200   FOR bep2 = 28 TO 1 STEP -1
4210     sc = sc + 1
4220     BEEP 0,bep2,bep2 + 2,.5,.5,5,10,10
4230     SCROLL #3,-sc
4240   END FOR bep2
4250   PAUSE 50 : BEEP
4260   PAN 120
4270 END DEFine 
4280 :
4290 :
4300 DEFine PROCedure logo
4310   log$ = 'QSQUIDGE'
4320   OVER #3,-1
4330   INK #3,6
4340   FOR l2 = 1 TO 8
4350     CURSOR #3,40,80 + l2 * 10
4360     PRINT #3,log$(l2)
4370   END FOR l2
4380   OVER #3,0
4390 END DEFine 
4400 :
4410 :
4420 DEFine PROCedure rocket
4430   BLOCK #3,50,90,20,90,7
4440   INK #3,7
4450   FILL #3,1
4460   LINE #3,11,10 TO 8,0 TO 17,0 TO 14,10
4470   FILL #3,0
4480   FILL #3,1
4490   LINE #3,22,10 TO 18,0 TO 27,0 TO 24,10
4500   FILL #3,0
4510   FILL #3,1
4520   LINE #3,7.5,55 TO 17,70 TO 26,55
4530   FILL #3,0
4540 END DEFine 
4550 :
4560 :
4570 DEFine PROCedure lose
4580   MODE 8 : POKE 98403,2
4590   OVER -1 : stars 400,200
4600   RESTORE 4690 : CSIZE 0,1
4610   PRINT \\ : c = 0
4620   FOR prt = 1 TO 7
4630     c = c + 1 : IF c = 8 THEN c = 1
4640     INK c
4650     READ endmessage$
4660     PRINT TO(36-LEN(endmessage$))/2;endmessage$
4670   END FOR prt
4680   CSIZE 0,0 : POKE 98403,8 : OVER 0
4690   DATA 'Tough Luck !','You failed to repair'
4700   DATA 'your SQUIDGE craft'
4710   DATA 'and return to your home !!'
4720   DATA '','Press any key to','play again....'
4730 END DEFine 
4740 :
4750 :
4760 DEFine PROCedure show_lives
4770   INK 5
4780   OVER -1
4790   lives = lives - 1
4800   CURSOR 400 + (lives * 12),10
4810   PRINT '' : REMark CTRL SHIFT .
4820   REMark CHR$(158)
4830   OVER 0
4840   FOR b = 5 TO 1 STEP -1
4850     BEEP 3000,b,b + 5,250,1,0,5,0
4860   END FOR b
4870 END DEFine 
